# E0717: namespace alias cannot use 'import type'


The error message "namespace alias cannot use 'import type'" occurs when
trying to use the 'import type' syntax with an alias.


```typescript
import type A = ns;
```


To fix this error, you need to use the regular 'import' syntax instead
of 'import type' when using an alias.


```typescript
import A = ns;
```
